public class SRE
{
/**
 * tell whether two Strings are the same, character by character
 * @param x   one String
 * @param y   the other String
 * @return    a boolean, true if they match
 */
    public static boolean sameString( String x, String y)
    {
        if (x.length()==0 && y.length() == 0)
        {
            return true;
        }
        else if (x.length() == 0 || y.length() == 0)
        {
            return false;
        }
        else // both are non-empty
        {
            return x.charAt(0) == y.charAt(0) &&
                   SRE.sameString(x.substring(1), y.substring(1));
        }
    }
    
/**
 * tell whether one string appears as PART of the other
 * @param target     the string to look for inside the other
 * @param big        the big string to search through
 * @return           a boolean, true if the target was found
 */
    public static boolean appearsAsSubsequence (String target, String big)
    {
        if (target.length()==0)
        {
            return true;
        }
        else if (big.length()==0)
        {
            return false;
        }
        else // both are non-empty
        {
           if (target.charAt(0) == big.charAt(0))
           {
              return SRE.appearsAsSubsequence (target.substring(1), big.substring(1));
            }
            else
            {
                return SRE.appearsAsSubsequence (target, big.substring(1));
            }
        }
    }
}
